/***************************************************************************/
/* F r e e C o d e                                                         */
/*                                                                         */
/* THIS CODE IS FREEWARE AND AS SUCH YOU ARE PERMITTED TO DO WHAT YOU WISH */
/* WITH IT. THESE PROGRAMS ARE PROVIDED AS IS WITHOUT ANY WARRANTY,        */
/* EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO FITNESS FOR ANY      */
/* PARTICULAR PURPOSE.                                                     */
/*                                                                         */
/* However, we would appriciate if you shared any enhancements to us       */
/* Please send them to www.jma.se/free/ and we will include them in        */
/* future distributions.                                                   */
/*                                                                         */
/***************************************************************************/
/****************************************************************************

     Modul:      tposd.cpp, cpp-source for Thinkpad OSD

     Version:    0.001

     Tid:        021213, 021213, 1h

    ---------------------------------------------------------------------
     021213:     Started writing. (JMA)
    ---------------------------------------------------------------------
****************************************************************************/
#define INCL_DOS
#define INCL_WIN
#define INCL_GPI

#include <os2.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#include "tposd.h"
#include "tp_cmos.h"

MRESULT EXPENTRY ClientWndProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
void SizeWindow (HWND hwnd, int iFlag);
void UpdateWindow (HWND hwnd, HPS hps);
void InitMenu (HWND hwndMenu);
void SetExeDirectory (void);
void LoadSettings (void);
void SaveSettings (void);
void MenuEnableItem (HWND hwndMenu, USHORT usMenuId, BOOL bEnabled);
void MenuCheckItem (HWND hwndMenu, USHORT usMenuId, BOOL bCheck);
char *xxstrnset( char *str, int fill, size_t count );

/* -------------------------------------------------------------------- */

HAB             hab;
SETTINGS        prfSet;


/*-----------------------------------------------------------------------------
   main: Entrypoint into this program.                               940524
-----------------------------------------------------------------------------*/
int main (int argc, char *argv[])
     {
     static CHAR szClassName [] = "Thinkpad OSD 0.001";
     HWND        hwndFrame,hwndClient;
     HMQ         hmq;
     QMSG        qmsg;

     ULONG       flFrameFlags=FCF_BORDER | FCF_TASKLIST | FCF_NOBYTEALIGN;


     hab = WinInitialize(0);
     hmq = WinCreateMsgQueue(hab, 0);

     WinRegisterClass(hab,szClassName, (PFNWP) ClientWndProc,
                      CS_SIZEREDRAW | CS_SYNCPAINT, 0);

     hwndFrame = WinCreateStdWindow (HWND_DESKTOP,
                                     0L,
                                     (PULONG)&flFrameFlags,
                                     szClassName,
                                     "",
                                     WS_VISIBLE,
                                     0L,
                                     0L,
                                     (PHWND) &hwndClient);

     SizeWindow (hwndClient, ID_FIRSTTIME);

     while (WinGetMsg (hab, &qmsg, (ULONG) NULL, 0L, 0L))
           WinDispatchMsg(hab, &qmsg);

     WinDestroyWindow(hwndFrame);
     WinDestroyMsgQueue(hmq);
     WinTerminate(hab);
     return(TRUE);
     }


/*-----------------------------------------------------------------------------
   ClientWndProc: Handles messages for the client window.
-----------------------------------------------------------------------------*/
MRESULT EXPENTRY ClientWndProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
     {
     static HWND        hwndMenu;
     static BOOL        bDrag;
     static int         iMouseX, iMouseY;

     HWND               hwndFrame;
     HPS                hps;
     POINTL             ptl;
     SWP                swp;
     ULONG              flOptions;
     RECTL              rcl;

     ULONG              ulAttrFound, ulColorValue;
     char               szBuffer[64+1];


     switch (msg)
          {

          case WM_CREATE:
               SetExeDirectory();
               LoadSettings();
               WinStartTimer(hab, hwnd, ID_TIMER, 1000);
               hwndMenu = WinLoadMenu(hwnd, NULLHANDLE, ID_RESOURCE);
               InitMenu (hwndMenu);
               bDrag = FALSE;
               break;

          case WM_BEGINDRAG:
               WinQueryPointerPos(HWND_DESKTOP, &ptl);
               WinMapWindowPoints(HWND_DESKTOP, hwnd, &ptl, 1);
               iMouseX = ptl.x;
               iMouseY = ptl.y;
               bDrag = TRUE;
               break;

          case WM_MOUSEMOVE:
               if (bDrag == TRUE)
                  return WinSendMsg(WinQueryWindow(hwnd, QW_PARENT), WM_TRACKFRAME, MPFROMSHORT(TF_MOVE), NULL);
               break;

          case WM_ENDDRAG:
               if (bDrag == TRUE)
                  {
                  WinQueryPointerPos(HWND_DESKTOP, &ptl);
                  prfSet.ptl.x = ptl.x - iMouseX;
                  prfSet.ptl.y = ptl.y - iMouseY;
                  bDrag = FALSE;
                  }
               break;

          case WM_CONTEXTMENU:
               WinQueryPointerPos(HWND_DESKTOP, &ptl);
               WinMapWindowPoints(HWND_DESKTOP, hwnd, &ptl, 1);
               flOptions = PU_KEYBOARD | PU_MOUSEBUTTON1 | PU_HCONSTRAIN | PU_VCONSTRAIN;
               WinPopupMenu(hwnd, hwnd, hwndMenu, ptl.x, ptl.y,
                            0, (USHORT) flOptions);
               break;

          case WM_TIMER:
               if (prfSet.bStayOnTop == TRUE)
                  WinSetWindowPos(WinQueryWindow(hwnd,QW_PARENT), HWND_TOP, 0L, 0L,
                                  0L, 0L, SWP_ZORDER);
               WinInvalidateRect(hwnd, NULL, FALSE);
               break;

          case WM_COMMAND:
               switch (SHORT1FROMMP(mp1))
                      {
                      case IDM_DATETIMEMEMORY:
                           if (prfSet.iDisplay != ID_DATETIMEMEMORY)
                              {
                              prfSet.iDisplay = ID_DATETIMEMEMORY;
                              MenuCheckItem(hwndMenu, IDM_DATETIMEMEMORY, TRUE);
                              MenuCheckItem(hwndMenu, IDM_DATETIME, FALSE);
                              MenuCheckItem(hwndMenu, IDM_TIMEONLY, FALSE);
                              SizeWindow(hwnd, ID_JUSTSIZE);
                              }
                           break;

                      case IDM_DATETIME:
                           if (prfSet.iDisplay != ID_DATETIME)
                              {
                              prfSet.iDisplay = ID_DATETIME;
                              MenuCheckItem(hwndMenu, IDM_DATETIMEMEMORY, FALSE);
                              MenuCheckItem(hwndMenu, IDM_DATETIME, TRUE);
                              MenuCheckItem(hwndMenu, IDM_TIMEONLY, FALSE);
                              SizeWindow(hwnd, ID_JUSTSIZE);
                              }
                           break;

                      case IDM_TIMEONLY:
                           if (prfSet.iDisplay != ID_TIMEONLY)
                              {
                              prfSet.iDisplay = ID_TIMEONLY;
                              MenuCheckItem(hwndMenu, IDM_DATETIMEMEMORY, FALSE);
                              MenuCheckItem(hwndMenu, IDM_DATETIME, FALSE);
                              MenuCheckItem(hwndMenu, IDM_TIMEONLY, TRUE);
                              SizeWindow(hwnd, ID_JUSTSIZE);
                              }
                           break;

                      case IDM_STAYONTOP:
                           if (prfSet.bStayOnTop == TRUE)
                              {
                              prfSet.bStayOnTop = FALSE;
                              MenuCheckItem(hwndMenu, IDM_STAYONTOP, FALSE);
                              }
                           else
                              {
                              prfSet.bStayOnTop = TRUE;
                              MenuCheckItem(hwndMenu, IDM_STAYONTOP, TRUE);
                              }
                           break;

                      case IDM_USUK:
                           break;

                      case IDM_SWEDEN:
                           break;

                      case IDM_ABOUT:
                           break;

                      case IDM_EXIT:
                           WinPostMsg(hwnd, WM_QUIT, 0L, 0L);
                           break;

                      default:
                           return WinDefWindowProc(hwnd, msg, mp1, mp2);
                      }
               break;

          case WM_SAVEAPPLICATION:
               SaveSettings();
               break;

          case WM_PAINT:
               hps = WinBeginPaint(hwnd, 0L, 0L);
               WinQueryWindowRect(hwnd, &rcl);
               WinFillRect(hps, &rcl, GpiQueryColorIndex(hps, 0L, prfSet.iBackColor));
               UpdateWindow (hwnd, hps);
               WinEndPaint(hps);
               break ;

          case WM_PRESPARAMCHANGED:
               switch (LONGFROMMP(mp1))
                      {
                      case PP_FONTNAMESIZE:
                           WinQueryPresParam(hwnd, PP_FONTNAMESIZE, 0, &ulAttrFound,
                                             sizeof(szBuffer), (PVOID) &szBuffer, 0L);
                           if (PP_FONTNAMESIZE == ulAttrFound)
                              {
                              strcpy(prfSet.szFontSize, szBuffer);
                              SizeWindow(hwnd, ID_JUSTSIZE);
                              }
                           break;

                      case PP_FOREGROUNDCOLOR:
                           WinQueryPresParam(hwnd, PP_FOREGROUNDCOLOR, 0, &ulAttrFound,
                                             sizeof(ulColorValue), (PVOID) &ulColorValue, 0L);
                           if (PP_FOREGROUNDCOLOR == ulAttrFound)
                              prfSet.iForeColor = ulColorValue;
                           break;

                      case PP_BACKGROUNDCOLOR:
                           WinQueryPresParam(hwnd, PP_BACKGROUNDCOLOR, 0, &ulAttrFound,
                                             sizeof(ulColorValue), (PVOID) &ulColorValue, 0L);
                           if (PP_BACKGROUNDCOLOR == ulAttrFound)
                              prfSet.iBackColor = ulColorValue;
                           break;

                      default:
                           return WinDefWindowProc (hwnd, msg, mp1, mp2);

                      }
               return FALSE;

          case WM_CLOSE:
          case WM_QUIT:
               WinStopTimer(hab, hwnd, ID_TIMER);
               SaveSettings();
               return WinDefWindowProc(hwnd, msg, mp1, mp2);

          default:
               return WinDefWindowProc(hwnd, msg, mp1, mp2);
          }
     return FALSE;
     }


/*-----------------------------------------------------------------------------
   SizeWindow: Sizes window using current font.
-----------------------------------------------------------------------------*/
void SizeWindow (HWND hwnd, int iFlag)
     {
     HWND               hwndFrame;
     FONTMETRICS        fm;
     HPS                hps;
     RECTL              rcl;
     int                xWidth, yHeight;

     hwndFrame = WinQueryWindow(hwnd, QW_PARENT);

     if (iFlag == ID_FIRSTTIME)
        {
        WinSetPresParam(hwnd, PP_FONTNAMESIZE, (ULONG)sizeof(prfSet.szFontSize), (PVOID)&prfSet.szFontSize);
        }

     hps = WinGetPS(hwnd);
     GpiQueryFontMetrics(hps, (LONG) sizeof fm, &fm);
     WinReleasePS(hps);

     switch (prfSet.iDisplay)
            {
            case ID_DATETIMEMEMORY:
                 xWidth = 12;
                 yHeight = 3;
                 break;

            case ID_DATETIME:
                 xWidth = 12;
                 yHeight = 2;
                 break;

            case ID_TIMEONLY:
                 xWidth = 10;
                 yHeight = 1;
                break;
            }

     rcl.yBottom = prfSet.ptl.y;
     rcl.yTop    = rcl.yBottom + (yHeight * fm.lMaxBaselineExt);
     rcl.xLeft   = prfSet.ptl.x;
     rcl.xRight  = rcl.xLeft + (xWidth * fm.lEmInc);

     WinCalcFrameRect(hwndFrame, &rcl, FALSE);

     WinSetWindowPos(hwndFrame, NULLHANDLE, rcl.xLeft, rcl.yBottom,
                     (rcl.xRight - rcl.xLeft), (rcl.yTop - rcl.yBottom),
                     SWP_SIZE | SWP_MOVE | SWP_SHOW);

     }


/*-----------------------------------------------------------------------------
   UpdateWindow: Updates window with date/time/mem.
-----------------------------------------------------------------------------*/
void UpdateWindow (HWND hwnd, HPS hps)
     {
     THINKPAD_CMOS      tpc;
     char               szBuffer[256];

     char               szDateBuffer[40];
     char               szTimeBuffer[40];
     char               szMemBuffer[40];
     ULONG              ulDataLength;
     ULONG              ulIndexForeColor, ulIndexBackColor;

     int                yTop;
     RECTL              rcl;


     ThinkpadGetCMOSValues(&tpc);

     memset(szBuffer, 0, 256);
     sprintf(szDateBuffer, "%c %s", tpc.bKeyMute_Toggle ? 'M' : 'V', xxstrnset(szBuffer, '=', tpc.iVolumeLevel));

     memset(szBuffer, 0, 256);
     sprintf(szTimeBuffer, "B %s", xxstrnset(szBuffer, '=', tpc.iBrightnessLevel));

     sprintf(szMemBuffer, "%s %s %s",
             tpc.bKeyExpand_Toggle ? "EXP" : "   ",
             tpc.bKeyThinklight_Toggle ? "TLITE" : "     ",
             tpc.bKeyZoom_Toggle ? "ZOOM" : "    ");

     ulIndexForeColor = GpiQueryColorIndex(hps, 0L, prfSet.iForeColor);
     ulIndexBackColor = GpiQueryColorIndex(hps, 0L, prfSet.iBackColor);

     switch (prfSet.iDisplay)
            {
            case ID_DATETIMEMEMORY:
                 WinQueryWindowRect(hwnd, &rcl);
                 yTop        = ((rcl.yTop - rcl.yBottom) / 3);
                 rcl.yBottom = yTop * 2;
                 WinDrawText(hps, -1, szDateBuffer, &rcl, ulIndexForeColor, ulIndexBackColor,
                             DT_LEFT | DT_VCENTER);

                 WinQueryWindowRect(hwnd, &rcl);
                 rcl.yTop    =  yTop;
                 WinDrawText(hps, -1, szMemBuffer, &rcl, ulIndexForeColor, ulIndexBackColor,
                             DT_LEFT | DT_VCENTER);

                 WinQueryWindowRect(hwnd, &rcl);
                 rcl.yTop    = yTop * 2;
                 rcl.yBottom = yTop;
                 WinDrawText(hps, -1, szTimeBuffer, &rcl, ulIndexForeColor, ulIndexBackColor,
                             DT_LEFT | DT_VCENTER);
                 break;

            case ID_DATETIME:
                 WinQueryWindowRect(hwnd, &rcl);
                 rcl.yBottom += (5 *rcl.yTop) / 11;
                 WinDrawText(hps, -1, szDateBuffer, &rcl, ulIndexForeColor, ulIndexBackColor,
                             DT_LEFT | DT_VCENTER);

                 WinQueryWindowRect(hwnd, &rcl);
                 rcl.yBottom -= (5 *rcl.yTop) / 11;
                 WinDrawText(hps, -1, szTimeBuffer, &rcl, ulIndexForeColor, ulIndexBackColor,
                             DT_LEFT | DT_VCENTER);
                 break;

            case ID_TIMEONLY:
                 WinQueryWindowRect(hwnd, &rcl);
                 WinDrawText(hps, -1, szTimeBuffer, &rcl, ulIndexForeColor, ulIndexBackColor,
                             DT_LEFT | DT_VCENTER);
                break;
            }
     }


/*-----------------------------------------------------------------------------
   InitMenu: Sets menu at startup.
-----------------------------------------------------------------------------*/
void InitMenu (HWND hwndMenu)
     {

     switch (prfSet.iDisplay)
            {
            case ID_DATETIMEMEMORY:
                 MenuCheckItem(hwndMenu, IDM_DATETIMEMEMORY, TRUE);
                 MenuCheckItem(hwndMenu, IDM_DATETIME, FALSE);
                 MenuCheckItem(hwndMenu, IDM_TIMEONLY, FALSE);
                 break;

            case ID_DATETIME:
                 MenuCheckItem(hwndMenu, IDM_DATETIMEMEMORY, FALSE);
                 MenuCheckItem(hwndMenu, IDM_DATETIME, TRUE);
                 MenuCheckItem(hwndMenu, IDM_TIMEONLY, FALSE);
                 break;

            case ID_TIMEONLY:
                 MenuCheckItem(hwndMenu, IDM_DATETIMEMEMORY, FALSE);
                 MenuCheckItem(hwndMenu, IDM_DATETIME, FALSE);
                 MenuCheckItem(hwndMenu, IDM_TIMEONLY, TRUE);
                break;
            }

            MenuCheckItem(hwndMenu, IDM_STAYONTOP, prfSet.bStayOnTop);

            MenuCheckItem(hwndMenu, IDM_USUK, TRUE);
            MenuCheckItem(hwndMenu, IDM_SWEDEN, FALSE);
            MenuEnableItem(hwndMenu, IDM_USUK, FALSE);
            MenuEnableItem(hwndMenu, IDM_SWEDEN, FALSE);
     }


/*-----------------------------------------------------------------------------
   SetExeDirectory: Sets the .EXE directory as current directory.
-----------------------------------------------------------------------------*/
void SetExeDirectory ()
     {
     auto APIRET        rc;
     auto PTIB          pTib;
     auto PPIB          pPib;
     static char        szBuffer[128];

     short              sCounter;

     DosGetInfoBlocks(&pTib, &pPib);
     rc = DosQueryModuleName(pPib->pib_hmte, sizeof(szBuffer), szBuffer);

     if (szBuffer[1] == ':')
        DosSetDefaultDisk((ULONG)(szBuffer[0] - 'A' + 1));

     sCounter = strlen(szBuffer);

     while ((szBuffer[sCounter] != '\\') && (sCounter > 0))
           sCounter--;

     if (sCounter > 0)
        {
        if (szBuffer[1] == ':' && sCounter == 2)
           {
           szBuffer[sCounter + 1] = '\0';
           DosSetCurrentDir(szBuffer);
           }
        else
           {
           szBuffer[sCounter] = '\0';
           DosSetCurrentDir(szBuffer);
           }
        }
     }


/*-----------------------------------------------------------------------------
   LoadSettings: Loads settings from the user profile.
-----------------------------------------------------------------------------*/
void LoadSettings (void)
     {
     ULONG              pulBufferMax;
     HINI               hIni;

     hIni = PrfOpenProfile(hab, "TPOSD.INI");

     pulBufferMax = sizeof(prfSet);
     if (PrfQueryProfileData(hIni, "OSD", "Settings", (PVOID) &prfSet, &pulBufferMax) != TRUE)
        {
        prfSet.ptl.x = 0;
        prfSet.ptl.y = 0;
        prfSet.iDisplay = 0;
        prfSet.bStayOnTop = FALSE;
        strcpy(prfSet.szFontSize, "10.System Proportional");
        prfSet.iForeColor = RGB_BLACK;
        prfSet.iBackColor = RGB_WHITE;
        PrfWriteProfileData(hIni, "OSD", "Settings", (PVOID) &prfSet, sizeof(prfSet));
        }
     PrfCloseProfile(hIni);
     }


/*-----------------------------------------------------------------------------
   SaveSettings: Saves settings to the user profile.
-----------------------------------------------------------------------------*/
void SaveSettings (void)
     {
     HINI               hIni;

     hIni = PrfOpenProfile(hab, "TPOSD.INI");
     PrfWriteProfileData(hIni, "OSD", "Settings", (PVOID) &prfSet, sizeof(prfSet));
     PrfCloseProfile(hIni);
     }


/****************************************************************************
  MenuEnableItem: Enable or disable menuitem.
****************************************************************************/
void MenuEnableItem (HWND hwndMenu, USHORT usMenuId, BOOL bEnabled)
     {
     USHORT             usFlag;

     if (!bEnabled)
        usFlag = MIA_DISABLED;
     else
        usFlag = TRUE;

     WinSendMsg(hwndMenu, MM_SETITEMATTR, MPFROM2SHORT(usMenuId, TRUE), MPFROM2SHORT(MIA_DISABLED, usFlag));
     }


/****************************************************************************
  MenuCheckItem: Check or uncheck menuitem.
****************************************************************************/
void MenuCheckItem (HWND hwndMenu, USHORT usMenuId, BOOL bCheck)
     {
     USHORT             usFlag;

     if (bCheck)
        usFlag = MIA_CHECKED;
     else
        usFlag = TRUE;
     WinSendMsg(hwndMenu, MM_SETITEMATTR, MPFROM2SHORT(usMenuId, TRUE), MPFROM2SHORT(MIA_CHECKED, usFlag));
     }


/*-----------------------------------------------------------------------------
   ThinkpadGetCMOSValues:
-----------------------------------------------------------------------------*/
void ThinkpadGetCMOSValues(PTHINKPAD_CMOS ptpc)
     {
     ptpc->bKeyHome_Toggle        = ( read_cmos(ID_BYTE_INETKEY) & 0x01);
     ptpc->bKeySearch_Toggle      = ( read_cmos(ID_BYTE_INETKEY) & 0x02) >> 1;
     ptpc->bKeyMail_Toggle        = ( read_cmos(ID_BYTE_INETKEY) & 0x04) >> 2;
     ptpc->bKeyThinkpad_Toggle    = ( read_cmos(ID_BYTE_POWER_MISC) & 0x08) >> 3;
     ptpc->bKeyZoom_Toggle        = ( ~read_cmos(ID_BYTE_POWER_MISC)  & 0x20) >> 5;
     ptpc->bKeyDisplay_Toggle     = ( read_cmos(ID_BYTE_POWER_MISC) & 0x40) >> 6;
     ptpc->bKeyThinklight_Toggle  = ( read_cmos(ID_BYTE_THINKLIGHT) & 0x10) >> 4;
     ptpc->bHibernate_Toggle      = ( read_cmos(ID_BYTE_THINKLIGHT) & 0x01);
     ptpc->iSelectedDisplay       = ( read_cmos(ID_BYTE_DISPLAYSTATE) & 0x03);
     ptpc->bKeyExpand_Toggle      = ( read_cmos(ID_BYTE_DISPLAYSTATE) & 0x10) >> 4;
     ptpc->iBrightnessLevel       = ( read_cmos(ID_BYTE_BRIGHTNESS) & 0x07);
     ptpc->bKeyBrightness_Toggle  = ( read_cmos(ID_BYTE_BRIGHTNESS) & 0x20) >> 5;
     ptpc->iVolumeLevel           = ( read_cmos(ID_BYTE_VOLUME) & 0x0f);
     ptpc->bKeyVolume_Toggle      = ( read_cmos(ID_BYTE_VOLUME) & 0x80) >> 7;
     ptpc->bKeyMute_Toggle        = ( read_cmos(ID_BYTE_VOLUME) & 0x40) >> 6;
     }

char *xxstrnset( char *str, int fill, size_t count )
     {
     int iCounter;

     for (iCounter = 0; iCounter < count; iCounter++)
         str[iCounter] = fill;
     return(str);
     }
